#ifdef HAS_DISPATCH

#ifndef CPU_DISPATCH_H
#define CPU_DISPATCH_H

#include <VapourSynth.h>


        extern const VSFrameRef *VS_CC DFTTestGetFrame_sse2(
            int n, int activationReason, void **instanceData, void **frameData,
            VSFrameContext *frameCtx, VSCore *core, const VSAPI *vsapi
        ) noexcept;

        extern const VSFrameRef *VS_CC DFTTestGetFrame_avx2(
            int n, int activationReason, void **instanceData, void **frameData,
            VSFrameContext *frameCtx, VSCore *core, const VSAPI *vsapi
        ) noexcept;

        extern const VSFrameRef *VS_CC DFTTestGetFrame_avx512f(
            int n, int activationReason, void **instanceData, void **frameData,
            VSFrameContext *frameCtx, VSCore *core, const VSAPI *vsapi
        ) noexcept;


extern bool supported_arch_sse2() noexcept;
extern bool supported_arch_avx2() noexcept;
extern bool supported_arch_avx512f() noexcept;


#endif // CPU_DISPATCH_H

#endif // HAS_DISPATCH
